#ifndef __NT_SYMLINK_PARSE__H__
#define __NT_SYMLINK_PARSE__H__

typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef unsigned long ULONG;

#define NTICE_REG "SYSTEM\\CurrentControlSet\\Services\\NTice\\DOSDeviceList"

typedef LONG NTSTATUS ;

#define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)

#define ExAllocatePool(fignia, sz)  GlobalAlloc(GMEM_DISCARDABLE, sz)
#define ExFreePool(ptr) GlobalFree(ptr)

#ifdef __cplusplus
extern "C" {
#endif //__cplusplus

extern OSVERSIONINFO OsVerInfo;
extern ULONG MajorVersion;
extern ULONG MinorVersion;

#ifdef __cplusplus
};
#endif //__cplusplus

#define WinVer_Is351  (MajorVersion==0x03 && MinorVersion==51)
#define WinVer_IsNT   (MajorVersion==0x04)
#define WinVer_Is2k   (MajorVersion==0x05 && MinorVersion==0x00)
#define WinVer_IsXP   (MajorVersion==0x05 && MinorVersion==0x01)
#define WinVer_IsdNET (MajorVersion==0x05 && MinorVersion==0x02)

#define MAX_UNI_PATH (1024*sizeof(WCHAR))

//
// Pointer to Unsigned Basics
//

typedef struct _UNICODE_STRING {
    USHORT Length;
    USHORT MaximumLength;
    PWSTR  Buffer;
} UNICODE_STRING;
typedef UNICODE_STRING *PUNICODE_STRING;

typedef struct _OBJECT_ATTRIBUTES {
    ULONG Length;
    HANDLE RootDirectory;
    PUNICODE_STRING ObjectName;
    ULONG Attributes;
    PVOID SecurityDescriptor;        // Points to type SECURITY_DESCRIPTOR
    PVOID SecurityQualityOfService;  // Points to type SECURITY_QUALITY_OF_SERVICE
} OBJECT_ATTRIBUTES;
typedef OBJECT_ATTRIBUTES *POBJECT_ATTRIBUTES;

#define InitializeObjectAttributes( p, n, a, r, s ) { \
    (p)->Length = sizeof( OBJECT_ATTRIBUTES );          \
    (p)->RootDirectory = r;                             \
    (p)->Attributes = a;                                \
    (p)->ObjectName = n;                                \
    (p)->SecurityDescriptor = s;                        \
    (p)->SecurityQualityOfService = NULL;               \
    }
#define OBJ_CASE_INSENSITIVE    0x00000040L

#define DIRECTORY_QUERY                 (0x0001)
#define DIRECTORY_TRAVERSE              (0x0002)
#define DIRECTORY_CREATE_OBJECT         (0x0004)
#define DIRECTORY_CREATE_SUBDIRECTORY   (0x0008)

#define SYMBOLIC_LINK_QUERY (0x0001)

__inline
NTSTATUS
RtlInitUnicodeString(PUNICODE_STRING ustr, PWCHAR buf) {
    ustr->Buffer = buf;
    ustr->Length = wcslen(buf)*sizeof(WCHAR);
    ustr->MaximumLength = ustr->Length+sizeof(WCHAR);
    return 0;
}

#ifdef __cplusplus
extern "C" {
#endif //__cplusplus

BOOLEAN
LocateNTDLLCalls();

BOOLEAN ParseSymLink(IN PUNICODE_STRING SrcUniName, OUT PUNICODE_STRING DstPathName);

#ifdef __cplusplus
};
#endif //__cplusplus

extern
ULONG (__stdcall *NtCreateSymbolicLinkObject)(
                PHANDLE SymbolicLinkHandle,
                ACCESS_MASK DesiredAccess,
                POBJECT_ATTRIBUTES ObjectAttributes,
                PUNICODE_STRING DeviceName);

extern
ULONG (__stdcall *NtOpenSymbolicLinkObject)(
                PHANDLE LinkHandle,
                ACCESS_MASK DesiredAccess,
                POBJECT_ATTRIBUTES ObjectAttributes);

extern
ULONG (__stdcall *NtQuerySymbolicLinkObject)(
                HANDLE LinkHandle,
                PUNICODE_STRING LinkTarget,
                PULONG ReturnedLength);

extern
ULONG (__stdcall *NtClose)(HANDLE Handle);

extern
ULONG (__stdcall *NtOpenDirectoryObject)(
    OUT PHANDLE hDirectory,
	IN ACCESS_MASK AccessMask,
	IN POBJECT_ATTRIBUTES ObjectAttributes);

#endif //__NT_SYMLINK_PARSE__H__